% Deguang Yu - CIS 601 - Home work #7
% Due: October 11th, 2004
%------------------------------------

clear all;
close all;

dim=10;

sample_height=64;
sample_width=64;
rowstart1=112;   
rowend1=rowstart1+sample_height-1;
colstart1=20;   
colend1=colstart1+sample_width-1;

rowstart2=112;
rowend2=rowstart2+sample_height-1;
colstart2=112;
colend2=colstart2+sample_width-1;

% Reads in all six texture pics
t1 = imread('texture1.jpg');
%figure; imshow(t1);
t1=double(t1);

i=rowstart1:rowend1;
j=colstart1:colend1;
t1_sample_1(i-rowstart1+1,j-colstart1+1)=t1(i,j);
t1_sample_11=reshape(t1_sample_1,sample_height*sample_width, 1);

i=rowstart2:rowend2;
j=colstart2:colend2;
t1_sample_2(i-rowstart2+1,j-colstart2+1)=t1(i,j);
t1_sample_22=reshape(t1_sample_2,sample_height*sample_width, 1);

t2 = imread('texture2.jpg');
%figure; imshow(t2);
t2=double(t2);

i=rowstart1:rowend1;
j=colstart1:colend1;
t2_sample_1(i-rowstart1+1,j-colstart1+1)=t2(i,j);
t2_sample_11=reshape(t2_sample_1,sample_height*sample_width, 1);

i=rowstart2:rowend2;
j=colstart2:colend2;
t2_sample_2(i-rowstart2+1,j-colstart2+1)=t2(i,j);
t2_sample_22=reshape(t2_sample_2,sample_height*sample_width, 1);

t3 = imread('texture3.jpg');
%figure; imshow(t3);
t3=double(t3);

i=rowstart1:rowend1;
j=colstart1:colend1;
t3_sample_1(i-rowstart1+1,j-colstart1+1)=t3(i,j);
t3_sample_11=reshape(t3_sample_1,sample_height*sample_width, 1);

i=rowstart2:rowend2;
j=colstart2:colend2;
t3_sample_2(i-rowstart2+1,j-colstart2+1)=t3(i,j);
t3_sample_22=reshape(t3_sample_2,sample_height*sample_width, 1);

t4 = imread('texture4.jpg');
%figure; imshow(t4);
t4=double(t4);

i=rowstart1:rowend1;
j=colstart1:colend1;
t4_sample_1(i-rowstart1+1,j-colstart1+1)=t4(i,j);
t4_sample_11=reshape(t4_sample_1,sample_height*sample_width, 1);

i=rowstart2:rowend2;
j=colstart2:colend2;
t4_sample_2(i-rowstart2+1,j-colstart2+1)=t4(i,j);
t4_sample_22=reshape(t4_sample_2,sample_height*sample_width, 1);

t5 = imread('texture5.jpg');
%figure; imshow(t5);
t5=double(t5);

i=rowstart1:rowend1;
j=colstart1:colend1;
t5_sample_1(i-rowstart1+1,j-colstart1+1)=t5(i,j);
t5_sample_11=reshape(t5_sample_1,sample_height*sample_width, 1);

i=rowstart2:rowend2;
j=colstart2:colend2;
t5_sample_2(i-rowstart2+1,j-colstart2+1)=t5(i,j);
t5_sample_22=reshape(t5_sample_2,sample_height*sample_width, 1);

t6 = imread('texture6.jpg');
%figure; imshow(t6);
t6=double(t6);

i=rowstart1:rowend1;
j=colstart1:colend1;
t6_sample_1(i-rowstart1+1,j-colstart1+1)=t6(i,j);
t6_sample_11=reshape(t6_sample_1,sample_height*sample_width, 1);

i=rowstart2:rowend2;
j=colstart2:colend2;
t6_sample_2(i-rowstart2+1,j-colstart2+1)=t6(i,j);
t6_sample_22=reshape(t6_sample_2,sample_height*sample_width, 1);

%assemble all smaple sub-images
samples=[];
samples=[samples t1_sample_11];
samples=[samples t1_sample_22];

samples=[samples t2_sample_11];
samples=[samples t2_sample_22];

samples=[samples t3_sample_11];
samples=[samples t3_sample_22];

samples=[samples t4_sample_11];
samples=[samples t4_sample_22];

samples=[samples t5_sample_11];
samples=[samples t5_sample_22];

samples=[samples t6_sample_11];
samples=[samples t6_sample_22];

%get EigenVectors and Values using PCA
[EigenVectors, Values] = pca(samples', dim);

%resize it 
FinalVectors=(reshape(EigenVectors',size(EigenVectors,2)*2,size(EigenVectors,1)/2))';

%calculate Euclidean distance for each pair of images
for i=1:6
    for j=(i+1):6
        distance(i,j)=norm(FinalVectors(i,:)-FinalVectors(j,:),2);    
    end        
end
