function [u,e_val] = pca(x, numvecs);

% subtracting the mean block from the blocks (normalize)
meanx = mean(x);

num=size(x,2);
for incr=1:num
    z(:,incr) = x(:,incr) - meanx(incr); %for each block vector we substrackt its mean from it
end

A = z;

%Calculating Eigen vectors and eigen values
[e_vec,e_val] = eig(A*A');
%size(e_val);

% Sort 
diagonal = diag(e_val);
temp_evec = zeros(size(e_vec,1), numvecs);
[diagonal,index] = sort(diagonal);
index = flipud(index);

for i = 1:numvecs
    temp_eval(i,i) = e_val(index(i),index(i));
    temp_evec(:,i) = e_vec(:,index(i));
end;

e_vec = temp_evec;
e_val = temp_eval;
u= temp_evec;

